public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Bernard Cafarelli" <voyageur@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-util/google-perftools/
Date: Thu, 15 Feb 2024 20:50:24 +0000 (UTC)	[thread overview]
Message-ID: <1708030219.50e5705ceb615fddd35e4ea300fe3418bea6d53a.voyageur@gentoo> (raw)

commit:     50e5705ceb615fddd35e4ea300fe3418bea6d53a
Author:     Bernard Cafarelli <voyageur <AT> gentoo <DOT> org>
AuthorDate: Thu Feb 15 20:49:55 2024 +0000
Commit:     Bernard Cafarelli <voyageur <AT> gentoo <DOT> org>
CommitDate: Thu Feb 15 20:50:19 2024 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=50e5705c

dev-util/google-perftools: add 2.15

Fix large page configure switch

Closes: https://bugs.gentoo.org/887273
Signed-off-by: Bernard Cafarelli <voyageur <AT> gentoo.org>

 dev-util/google-perftools/Manifest                 |   1 +
 .../google-perftools/google-perftools-2.15.ebuild  | 118 +++++++++++++++++++++
 dev-util/google-perftools/metadata.xml             |  20 ++++
 3 files changed, 139 insertions(+)

diff --git a/dev-util/google-perftools/Manifest b/dev-util/google-perftools/Manifest
index 4957d61fd891..d7f8811fa9f0 100644
--- a/dev-util/google-perftools/Manifest
+++ b/dev-util/google-perftools/Manifest
@@ -1,2 +1,3 @@
 DIST gperftools-2.10.tar.gz 926512 BLAKE2B e92fb751f9e695d21edf5fce443f3d3641fcff15cbd6b5d868bc77fbe622594be824b75c8d45513c7f82b9e574c690133b8502d4574162948a77886d5166b92d SHA512 4400711723be9401f519d85b3b69c026e4715473cbed48ab0573df17abdf895fb971ee969875fe5127a2e8b9aba90d858285e50c8e012384c2c36d5a76b1f0c4
+DIST gperftools-2.15.tar.gz 888271 BLAKE2B 0fb627e36d6677d01081b1d566ad42eee8b87ab94a07cbbc4536a1671b539354bc0d27f6eab249e94317f0d57a9801551aa3b2cceae784231ac69528b61d4d6e SHA512 04551bdfac50812dd8305e0fe6f6ae5b8603f18a5f9cde56657daa634982bfb5eb5303721ea6a8e02f4177aa012535216f1c99b9eda4ce92f046982df41fbcd1
 DIST gperftools-2.9.1.tar.gz 924910 BLAKE2B fcf0491e42ff4212a63ab0af422f27f5a625c53a0b33e69f8dede96b004a0f01af104d9791a4b75d38145ae0059f5e2967ea1d09b0712cc4d930ef7aafd4f3ba SHA512 5e07f28da9afc5f1ba3df7f06ad0e146c171d33e1779bbaab21547ed234aaced02e5278c1eb8f92fc45480abd2474d6a2d4c71644fb9378f41088c56cc1bc8ab

diff --git a/dev-util/google-perftools/google-perftools-2.15.ebuild b/dev-util/google-perftools/google-perftools-2.15.ebuild
new file mode 100644
index 000000000000..93208aa22f2d
--- /dev/null
+++ b/dev-util/google-perftools/google-perftools-2.15.ebuild
@@ -0,0 +1,118 @@
+# Copyright 1999-2024 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+MY_P="gperftools-${PV}"
+inherit flag-o-matic autotools vcs-snapshot multilib-minimal
+
+DESCRIPTION="Fast, multi-threaded malloc() and nifty performance analysis tools"
+HOMEPAGE="https://github.com/gperftools/gperftools"
+SRC_URI="https://github.com/gperftools/gperftools/archive/${MY_P}.tar.gz"
+
+LICENSE="MIT"
+SLOT="0/4"
+# contains ASM code, with support for
+# freebsd x86/amd64
+# linux amd64/arm/arm64/ppc/ppc64/riscv/x86
+# OSX ppc/amd64
+# AIX ppc/ppc64
+KEYWORDS="-* ~amd64 ~arm ~arm64 ~ppc ~ppc64 ~riscv ~x86 ~amd64-linux ~x86-linux"
+
+IUSE="pagesize-16k pagesize-32k pagesize-64k pagesize-128k pagesize-256k +debug llvm-libunwind minimal optimisememory test static-libs"
+REQUIRED_USE="?? ( pagesize-16k pagesize-32k pagesize-64k pagesize-128k pagesize-256k )"
+
+RESTRICT="!test? ( test )"
+
+DEPEND="
+	llvm-libunwind? ( sys-libs/llvm-libunwind:= )
+	!llvm-libunwind? ( sys-libs/libunwind:= )
+"
+RDEPEND="${DEPEND}"
+
+S="${WORKDIR}/${MY_P}"
+
+PATCHES=(
+	# Please keep this if possible on bumps, check Fedora if needs rebasing
+	# Allows correct functionality on e.g. arm64, bug #818871
+	"${FILESDIR}"/${PN}-2.9.1-disable-generic-dynamic-tls.patch
+)
+
+pkg_setup() {
+	# set up the make options in here so that we can actually make use
+	# of them on both compile and install.
+
+	# Avoid building the unit testing if we're not going to execute
+	# tests; this trick here allows us to ignore the tests without
+	# touching the build system (and thus without rebuilding
+	# autotools). Keep commented as long as it's restricted.
+	use test || \
+		MAKEOPTS+=" noinst_PROGRAMS= "
+}
+
+src_prepare() {
+	default
+
+	eautoreconf
+	multilib_copy_sources
+}
+
+multilib_src_configure() {
+	use optimisememory && append-cppflags -DTCMALLOC_SMALL_BUT_SLOW
+	use pagesize-16k && append-cppflags -DTCMALLOC_PAGE_SIZE_SHIFT=14
+	use pagesize-32k && append-cppflags -DTCMALLOC_PAGE_SIZE_SHIFT=15
+	use pagesize-64k && append-cppflags -DTCMALLOC_PAGE_SIZE_SHIFT=16
+	use pagesize-128k && append-cppflags -DTCMALLOC_PAGE_SIZE_SHIFT=17
+	use pagesize-256k && append-cppflags -DTCMALLOC_PAGE_SIZE_SHIFT=18
+	append-flags -fno-strict-aliasing -fno-omit-frame-pointer
+
+	local myeconfargs=(
+		--enable-shared
+		$(use_enable static-libs static)
+		$(use_enable debug debugalloc)
+	)
+
+	if [[ ${ABI} == x32 ]]; then
+		myeconfargs+=( --enable-minimal )
+	else
+		myeconfargs+=( $(use_enable minimal) )
+	fi
+
+	if use arm64 || use s390; then
+		# Use the same arches for disabling TLS (thread local storage)
+		# as Fedora, but we might need to expand this list if we get
+		# more odd segfaults in consumers like in bug #818871.
+		myeconfargs+=( --disable-general-dynamic-tls )
+	fi
+
+	econf "${myeconfargs[@]}"
+}
+
+src_test() {
+	if has sandbox ${FEATURES}; then
+		ewarn "Unable to run tests when sandbox is enabled."
+		ewarn "See https://bugs.gentoo.org/290249"
+		return 0
+	fi
+
+	multilib-minimal_src_test
+}
+
+src_install() {
+	if ! use minimal && has x32 ${MULTILIB_ABIS}; then
+		MULTILIB_WRAPPED_HEADERS=(
+			/usr/include/gperftools/heap-checker.h
+			/usr/include/gperftools/heap-profiler.h
+			/usr/include/gperftools/stacktrace.h
+			/usr/include/gperftools/profiler.h
+		)
+	fi
+
+	multilib-minimal_src_install
+}
+
+multilib_src_install_all() {
+	einstalldocs
+
+	use static-libs || find "${ED}" -name '*.la' -delete || die
+}

diff --git a/dev-util/google-perftools/metadata.xml b/dev-util/google-perftools/metadata.xml
index edf21deb1a1b..1e3420600a79 100644
--- a/dev-util/google-perftools/metadata.xml
+++ b/dev-util/google-perftools/metadata.xml
@@ -16,6 +16,26 @@
 			memory usage, but should speed up the allocation/free
 			operations.
 		</flag>
+		<flag name="pagesize-16k">
+			Use 16K page size for tcmalloc. Larger size makes tcmalloc faster,
+			at the cost of using more space (due to internal fragmentation)
+		</flag>
+		<flag name="pagesize-32k">
+			Use 32K page size for tcmalloc. Larger size makes tcmalloc faster,
+			at the cost of using more space (due to internal fragmentation)
+		</flag>
+		<flag name="pagesize-64k">
+			Use 64K page size for tcmalloc. Larger size makes tcmalloc faster,
+			at the cost of using more space (due to internal fragmentation)
+		</flag>
+		<flag name="pagesize-128k">
+			Use 128K page size for tcmalloc. Larger size makes tcmalloc faster,
+			at the cost of using more space (due to internal fragmentation)
+		</flag>
+		<flag name="pagesize-256k">
+			Use 256K page size for tcmalloc. Larger size makes tcmalloc faster,
+			at the cost of using more space (due to internal fragmentation)
+		</flag>
 		<flag name="debug">
 			Build a set of libraries with debug support (so-called
 			debugalloc). These are available by default but are not needed


             reply	other threads:[~2024-02-15 20:50 UTC|newest]

Thread overview: 65+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2024-02-15 20:50 Bernard Cafarelli [this message]
  -- strict thread matches above, loose matches on Subject: below --
2024-10-04 14:49 [gentoo-commits] repo/gentoo:master commit in: dev-util/google-perftools/ Bernard Cafarelli
2024-10-04 14:49 Bernard Cafarelli
2024-06-20 20:11 Arthur Zamarin
2024-06-20 20:11 Arthur Zamarin
2024-06-20 20:10 Arthur Zamarin
2024-06-20 20:10 Arthur Zamarin
2024-06-20 18:06 Sam James
2024-06-19 19:43 Arthur Zamarin
2024-03-02 22:16 Bernard Cafarelli
2024-03-02 13:22 Arthur Zamarin
2024-02-24 10:20 Bernard Cafarelli
2024-02-17 14:48 Sam James
2024-02-15 20:03 Sam James
2024-02-15 20:03 Sam James
2024-02-15 18:34 Jakov Smolić
2024-02-15 18:34 Jakov Smolić
2024-02-15 13:11 Bernard Cafarelli
2022-09-02 21:28 Sam James
2022-07-15  1:32 Sam James
2021-10-27 22:54 Sam James
2021-10-27 22:47 Sam James
2021-10-27 22:47 Sam James
2021-10-27 22:35 Sam James
2021-10-27 22:35 Sam James
2021-10-27 22:33 Sam James
2021-10-27  5:37 Sam James
2021-10-27  5:34 Sam James
2021-07-11 22:02 Marek Szuba
2021-07-11 22:02 Marek Szuba
2021-06-15 18:47 Georgy Yakovlev
2020-08-21  6:13 Georgy Yakovlev
2020-08-21  3:12 Georgy Yakovlev
2020-06-06 17:38 Agostino Sarubbo
2020-06-06 17:34 Agostino Sarubbo
2020-06-06 17:32 Agostino Sarubbo
2020-06-06 17:29 Agostino Sarubbo
2020-06-06 17:27 Agostino Sarubbo
2020-06-06  8:33 Georgy Yakovlev
2020-06-06  7:36 Georgy Yakovlev
2020-04-15  4:29 Georgy Yakovlev
2020-04-15  2:42 Georgy Yakovlev
2020-04-15  2:42 Georgy Yakovlev
2020-02-09 13:14 David Seifert
2019-04-25  3:52 Aaron Bauman
2018-10-14 11:40 Pacho Ramos
2018-10-14 10:18 Pacho Ramos
2018-01-23  5:58 Markus Meier
2017-12-19  3:09 Lars Wendler
2017-12-19  3:09 Lars Wendler
2017-12-15  9:36 Jason Zaman
2017-12-09 14:54 Sergei Trofimovich
2017-12-08 21:58 Thomas Deutschmann
2017-12-01  5:08 Zac Medico
2017-08-10 15:49 Guilherme Amadio
2017-07-30 20:31 Patrick McLean
2017-07-30 20:31 Patrick McLean
2017-07-29 23:24 Patrick McLean
2017-07-07 18:15 Alexis Ballier
2017-02-15 23:14 Michael Weber
2016-12-29  4:12 Göktürk Yüksek
2016-09-27  7:57 Michał Górny
2016-06-08  6:29 Yixun Lan
2015-09-21  4:58 Jeroen Roovers
2015-09-01 19:31 Tobias Klausmann

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1708030219.50e5705ceb615fddd35e4ea300fe3418bea6d53a.voyageur@gentoo \
    --to=voyageur@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox